/*
program pro master cip ATMEGA16 ridici cip generatoru, DP
pro simulovani cidel, zobrazovani na LCD a ovladani pomoci
4tlac. klavesnice
*/
/////------KNIHOVNY-----------///////
#include <stdio.h>
#include <stdlib.h>
#include <avr/eeprom.h>
#include <ctype.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "SPI.H"
#include "LCD.H"

/////------KONSTANTY-----------///////
#define 	PRODLEVA	2000
//--KONSTANTY PRO DP--//
#define 	KROK_DP_AMP			20 
#define 	KROK_DP_OLEJ		1
#define		MAX_HOD_DP_OLEJ    247
#define		MIN_HOD_DP_OLEJ    255
//--KONSTANTY PRO LCD--//
#define		PoziceUvodu			0x03		
#define		PoziceJmeno			0x1a
#define		PoziceNa3radce 		0x11
#define		PoziceNa1radce		0x01
//--KONSTANTY PRO KLAVESNICI--//
#define 	DL_STISK   			250
#define 	KR_STISK   			4 

/////------STRUKTURY-----------///////

/////------PROMENNE-----------///////
volatile uint8_t druhSig = 0,
				 krStisk=0, DlStisk=0,
				 DelkaStisk=0, dlstisk=0, krstisk=1,
				 i, j, SPIData[4][2], SPItoATMEGA162,
				 gen_rezim=0, zmena_modu=0, zmena_DP=0;

/////====------FCE.-----------====///////
void InitPORTs(void){

	DDRA  = SET_ALL;	//pro LCD
	DDRC = SET_ALL;	//pro LCD
	DDRD = 0b10000011;	//klavesnice + LED	
	PORTD = 0b01111100;	//zapnuti pull-up pro klavesnici a tlac. na PD2
}
void INT1_Init(void){

	GICR |= (1<<INT1);//aktivovano INT1
	MCUCR |= (1<<ISC11)|(1<<ISC10);
}
/*----Fce. pro obsluhu preruseni TIMER2 pro rozliseni
kratkeho bo dlouheho stisku----*/	
ISR(TIMER2_COMP_vect){

	if(!(PIND &(1<<PD2))){	
		DelkaStisk++;
		if((DelkaStisk >= KR_STISK)&&(DelkaStisk < DL_STISK)){
			krStisk = 1;
					
		}
		if(DelkaStisk == DL_STISK){ 
			DlStisk = 1; 
			
		}
		if(DelkaStisk == 255) DelkaStisk = 0;
		
	}		
}
/*----Fce. pro obsluhu preruseni INT1 generovaneho
z prioritniho koderu----*/	
ISR(INT1_vect){	
	//cli();
	//--stisk tlac pro zvys.odporu na DP--//
	if(!(PIND & ((1<<PD6)|(1<<PD5)|(1<<PD4)))){		

		switch(zmena_DP){
			case 0b00 : SPIData[0][1] -= KROK_DP_AMP; //data pro MCP41100, data byte
			break;
			case 0b11 :{
						if(SPIData[3][1] <= MAX_HOD_DP_OLEJ) SPIData[3][1] = MIN_HOD_DP_OLEJ;//omezeni proti zvyseni odporu nad danou mez cca 180ohm
						else SPIData[3][1] -= KROK_DP_OLEJ; //data pro MCP42010, data byte
			}
			break;
		}		
		CLEAR_SS_DP;
			for(i=0;i<=3;i++){
				for(j=0;j<=1;j++){
					SPI_MasterTransmit(SPIData[i][j]);
					//asm volatile ("nop");
				}
			}					
		SET_SS_DP;
	}
	//--stisk tlac pro sniz.odporu na DP--//   
	if(PIND & ((1<<PD6)|(0<<PD5)|(0<<PD4))){    

		PORTD |= (1<<PD7);//kontrolni LED 
		
		switch(zmena_DP){
			case 0b00 : SPIData[0][1] += KROK_DP_AMP; //data pro MCP41100, data byte
			break;
			case 0b11 : {
						if(SPIData[3][1] >= MIN_HOD_DP_OLEJ) SPIData[3][1] = MAX_HOD_DP_OLEJ;//pri prekroceni min.hodnoty odporu se nastavi max.hod.odporu
						else SPIData[3][1] += KROK_DP_OLEJ; //data pro MCP42010, data byte
			}			
			break;			
		}		
		CLEAR_SS_DP;
			for(i=0;i<=3;i++){
				for(j=0;j<=1;j++){
					SPI_MasterTransmit(SPIData[i][j]);
					//asm volatile ("nop");
				}
			}					
		SET_SS_DP;
	}	
	//--stisk tlac pro zap/vyp sumu--//   
	/*
	if((PIND == 0b10101111)&&!gen_rezim){   

		CLEAR_SS_MEGA162;
		 	 	 	
	    SPI_MasterTransmit(SPItoATMEGA162);
			
	    SET_SS_MEGA162;	
	}*/
	//sei();

}
//----Inicializace casovace pro dlouhy/kratky stisk----//
void TIMER2init(void){

	TCCR2 |= (1<<WGM21)|(1<<CS22)|(1<<CS21);/*CTC mod,
	preddelicka 256, fosc=1MHz*/
	TIMSK |= (1<<OCIE2);//Output Compare Match Interrupt Enable
	OCR2 = 31;//8ms
	TCNT2 = 75;
}
int main(void){	

	InitPORTs();
	SPI_MasterInit();
	INT1_Init();
	LCDinit();
	TIMER2init();

	//---inicializace prom. pro DP---//
	SPIData[3][0] = 0b00010011; //data pro MCP42010_tepOleje, command byte
	SPIData[3][1] = 255; //data pro MCP42010, zap. PW0-PA0, data byte
	SPIData[2][0] = 0b00010011; //data pro MCP42010_KTY, command byte
	SPIData[2][1] = 1; //data pro MCP42010, data byte
	SPIData[1][0] = 0b00010011; //data pro MCP42050_tlak, command byte
	SPIData[1][1] = 1; //data pro MCP42050, data byte
	SPIData[0][0] = 0b00010001; //data pro MCP41100, command byte
	SPIData[0][1] = 28; //data pro MCP41100, data byte
	//---konec inicializace prom. pro DP---//

	//--uvodni obr.--//
	ClearLCD;
	_delay_ms(2);
	LCD_gotoXY(PoziceUvodu);
	SENDstringToLCD("Tester PLC");
	LCD_gotoXY(PoziceJmeno);
	SENDstringToLCD("ZH,TUL");
	_delay_ms(7000);	
	ClearLCD; 
	//--konec uvod.obr--//	

	//---zacatek prenosu hodnot do DP---//
	CLEAR_SS_DP;

	for(i=0;i<=3;i++){
		for(j=0;j<=1;j++){
			SPI_MasterTransmit(SPIData[i][j]);
			//asm volatile ("nop");
		}
	}		
	SET_SS_DP;	
	//---konec prenos hodnot do DP---//
	
	_delay_ms(1);
	LCD_gotoXY(START_LINE1);
	SENDstringToLCD("Presun hod.do DP");	
	LCD_gotoXY(PoziceNa3radce);
	SENDstringToLCD("DAISY-CHAIN mod");
	_delay_ms(4000);
	ClearLCD; 
	_delay_ms(2);

	sei();
	
	for(;;){
		//kratky stisk v rezimu kratkeho stisku
		if(krStisk && krstisk){
			PORTD ^= (1<<PD0);
			PORTD &= ~(1<<PD1);
			krStisk = 0;
			gen_rezim = 0;			
		}
		//kratky stisk v rezimu dlouheho stisku				
		if(krStisk && dlstisk){
			PORTD ^= (1<<PD1);
			PORTD &= ~(1<<PD0);
			krstisk = 0;
			krStisk = 0;
			gen_rezim = 1;
		}
		//dlouhy stisk v rezimu kratkeho stisku			
		if(DlStisk && krstisk){
			dlstisk = 1;
			krstisk = 0;
			DlStisk = 0;
			PORTD ^= (1<<PD1);
			PORTD &= ~(1<<PD0);
			zmena_modu = 1;			
		}
		//dlouhy stisk v rezimu dlouheho stisku			
		if(DlStisk && dlstisk && !krstisk){
			dlstisk = 0;
			krstisk = 1;
			PORTD |= (1<<PD0);
			PORTD &= ~(1<<PD1);
			DlStisk = 0;
			zmena_modu = 0;			
		}		
		if(!gen_rezim){			
			if(!zmena_modu){
				ClearLCD; 
				_delay_ms(2);
			}			
			LCD_gotoXY(PoziceNa1radce);
			SENDstringToLCD("Gener. rezim");
			LCD_gotoXY(PoziceNa3radce);
			SENDstringToLCD("sinus prubeh");
			
			_delay_ms(1000);

			ClearLCD; 
			_delay_ms(2);
			LCD_gotoXY(START_LINE1);
			SENDstringToLCD("GenR");
			LCD_gotoXY(0x0b);
			SENDstringToLCD("Sinus");
			LCD_gotoXY(START_LINE3);
			SENDstringToLCD("A=");
			LCD_gotoXY(0x17);
			SENDstringToLCD("f=");
	
			zmena_DP = 0b00;//urcuje DP pro zmenu amplitudy
		}
		else{
			ClearLCD; 
			_delay_ms(2);	
			LCD_gotoXY(PoziceNa1radce);
			SENDstringToLCD("Simulacni rezim");				
			LCD_gotoXY(PoziceNa3radce);
			SENDstringToLCD("Teplota oleje");
		
			_delay_ms(1000);
	
			ClearLCD; 
			_delay_ms(2);
			LCD_gotoXY(START_LINE1);
			SENDstringToLCD("SimR");
			LCD_gotoXY(START_LINE3);
			SENDstringToLCD("Tep.oleje");
			zmena_DP = 0b11;//urcuje DP pro zmenu teploty
		}				
		_delay_ms(5);//ochrana pred blikanim displeje	
	}
	return 0;
}
